// GLOBALE VARIABLE


// SONSTIGE-FUNKTIONEN
var FKT_whitespace = function(str) {
	var cond = true;
	while(cond) {
		cond = false;
		str = str.replace(/(\r|\t|\n)/g, function() {cond=true; return '';});
		str = str.replace(/\ \ /g, function() {cond=true; return ' ';});
	}
	str = str.replace(/^\s+/,function() {return '';});
	str = str.replace(/\s+$/,function() {return '';});
	return str;
};

var FKT_deselektieren = function() {
	if (document.selection) {
		document.selection.empty();
	} else if (window.getSelection) {
		window.getSelection().removeAllRanges();
	}
};

var FKT_getinbody = function(tag) {
	var bodies = document.getElementsByTagName('body');
	var n = bodies.length;
	var list = [];
	for(var k=0; k<n; k++) {
		list = list.concat(bodies[k].getElementsByTagName(tag))
	}
	return list;
};


// HAUPT-FUNKTIONEN
var FKT_impressum = function (tag) {
	var elemente = document.getElementsByTagName(tag);
	var match = null;
	var i = 0;
	var found = false;	// markiert, ob Match & Weiterleitung gefunden wurden.
	var reason = {tag: null, node: null, regex: {typ: null, text: null}, trigger: {typ: null, forced: null, obj: null}};
	var grund = null;

	while(i<matches.length && !found) {
		var j = 0;
		var regex = matches[i];
		while(j<elemente.length && !found) {
			var node = elemente[j];
			var innerHTML = node.innerHTML;
			var textContent = '';
			var value = '';
			var url = '';
			if(node.tagName == 'INPUT' || node.tagName == 'TEXTAREA') node.value ? value = node.value : value = '';
			node.textContent ? displaytext = node.textContent : displaytext = '';
			node.href ? url = node.href : url = '';
			var f = (function(node) {
				return function() {node.click.bind(node)();};
			})(node);

			reason.tag = node.tagName;
			reason.node = FKT_whitespace(node.outerHTML);

			// Höchste Priorität: innerHTML ≈ „Impressum“ o. Ä.:
			if(regex.test(innerHTML)) {
				reason.regex = {typ: 'innerHTML', text: innerHTML};
				if(node.hasAttribute('onclick')) {
					reason.trigger = {typ: 'onclick', forced: false, obj: []};
				} else {
					reason.trigger = {typ: 'onclick', forced: true, obj: []};
				}
				found = true;
			// 2. Priorität: textContent ≈ „Impressum“ o. Ä.:
			} else if(regex.test(textContent)) {
				reason.regex = {typ: 'textContent', text: textContent};
				// PRIORITISERE: falls dem Element per HTML onclick-Event zugeordnet wurde:
				if(node.hasAttribute('onclick')) {
					reason.trigger = {typ: 'onclick', forced: false, obj: []};
					found = true;
				} else if(url.length > 0) {
					reason.trigger = {typ: 'href', forced: !node.hasAttribute('href'), obj: url};
					f = (function(url) {
						return function() {window.open(url,'_self')};
					})(url);
					found = true;
				}
			// 3. Priorität: value ≈ „Impressum“ o. Ä.:
			} else if(regex.test(value)) {
				reason.regex = {typ: 'value', text: value};
				// PRIORITISERE: falls dem Element per HTML onclick-Event zugeordnet wurde:
				if(node.hasAttribute('onclick')) {
					reason.trigger = {typ: 'onclick', forced: false, obj: []};
					found = true;
				} else if(url.length > 0) {
					reason.trigger = {typ: 'href', forced: !node.hasAttribute('href'), obj: url};
					f = (function(url) {
						return function() {window.open(url,'_self')};
					})(url);
					found = true;
				}			
			}

			// Nur sichtbare Elemente mit einbeziehen:
			if(nursichtbar) cond = cond && node.sichtbar();
			if(found) match = {el: node, fkt: f};
			j++
		}
		i++;
	}

	if(found) {
		grund = 'Gefunden wurde ein {'+reason.tag+'}-Element, '+reason.node+',';
		grund += ' dessen {'+reason.regex.typ+'}-Attribut, {'+FKT_whitespace(reason.regex.text)+'},';
		grund += ' ein passendes erkennbares Textmatch aufwies.'
		if (reason.trigger.typ == 'onclick') {
			var p = match.el;
			while(!(p == null) && !(p.tagName == 'BODY')) {
				if(p.hasAttribute('onclick')) reason.trigger.obj.push(p.getAttribute('onclick'));
				p = p.parentNode;
			}
			if(reason.trigger.forced) {
				grund += ' Der {'+reason.trigger.typ+'}-Eventtrigger';
				var n = reason.trigger.obj.length;
				reason.trigger.obj.forEach(function(fstr) {
					grund += '\n\t'+fstr;
				});
				if(n>0) {
					grund += '\n';
				} else {
					grund += ' ';
				}
				grund += 'des Elements wurde zwangsweise ausgelöst.';
			} else {
				grund += ' Im Element wurde ein '+reason.trigger.typ+'-Eventtrigger entdeckt:'
				var n = reason.trigger.obj.length;
				reason.trigger.obj.forEach(function(fstr) {
					grund += '\n\t'+fstr;
				});
				if(n>0) {
					grund += '\n';
				} else {
					grund += ' ';
				}
				grund += 'und künstlich ausgelöst.';
			}
		} else if(reason.trigger.typ == 'href') {
			grund += ' Der Sicherheit halber, wurde kein onclick-Attribut ausgelöst.'
			if(reason.trigger.forced) {
				grund += ' Stattdessen wurde dem Element sein {'+reason.trigger.typ+'}-Attribut abgelesen';
				grund += '\n\t{'+reason.trigger.obj+'}';
				grund += '\nund auf diese Seite weitergeleitet.';
			} else {
				grund += ' Stattdessen wurde dem Element sein '+reason.trigger.typ+'-Attribut zwangshaft abgelesen';
				grund += '\n\t{'+reason.trigger.obj+'}';
				grund += '\nund auf diese Seite weitergeleitet.';
			}
		}
	}

	return {found: found, match: match, grund: grund};
};